Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -7171,16 +7695,40 @@ static unsigned int WriteOnePNGImage(Mng
                        bp.x,bp.y);
         }
     }
-  ping_info->interlace_type=image_info->interlace != NoInterlace;
 
-  if (mng_info->write_mng)
-    png_set_sig_bytes(ping,8);
+  png_write_info(ping,ping_info);
 
-  if (logging)
-    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                          "  Writing PNG header chunks");
+  /* write orNT if image->orientation is defined and not TopLeft */
+  if (image->orientation > 1 && image->orientation < 9)
+    {
+      unsigned char
+        chunk[6];
+      (void) WriteBlobMSBULong(image,1L);  /* data length=1 */
+      PNGType(chunk,mng_orNT);
+      LogPNGChunk(logging,mng_orNT,1L);
+      chunk[4]=image->orientation;
+      (void) WriteBlob(image,5,chunk);
+      (void) WriteBlobMSBULong(image,crc32(0,chunk,5));
+    }
 
-  png_write_info(ping,ping_info);
+  /* write caNv chunk */
+  if ((image->page.width != 0 && image->page.width != image->columns) ||
+      (image->page.height != 0 && image->page.height != image->rows) ||
+      image->page.x != 0 || image->page.y != 0)
+    {
+      unsigned char
+        chunk[22];
+
+      (void) WriteBlobMSBULong(image,16L);  /* data length=16 */
+      PNGType(chunk,mng_caNv);
+      LogPNGChunk(logging,mng_caNv,16L);
+      PNGLong(chunk+4,(png_uint_32) image->page.width);
+      PNGLong(chunk+8,(png_uint_32) image->page.height);
+      PNGsLong(chunk+12,(png_int_32) image->page.x);
+      PNGsLong(chunk+16,(png_int_32) image->page.y);
+      (void) WriteBlob(image,20,chunk);
+      (void) WriteBlobMSBULong(image,crc32(0,chunk,20));
+    }
 
 #if (PNG_LIBPNG_VER == 10206)
   /* avoid libpng-1.2.6 bug by setting PNG_HAVE_IDAT flag */
@@ -7193,46 +7741,65 @@ static unsigned int WriteOnePNGImage(Mng
   /*
     Allocate memory.
   */
+  if (logging)
+    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                          "  mng_info: columns=%lu, image_depth=%u, "
+                          "write_png8=%u, write_png24=%u, write_png32=%u "
+                          "write_png48=%u, write_png64=%u, IsPalette=%u, "
+                          "image_matte=%u",
+                          image->columns, image_depth, mng_info->write_png8,
+                          mng_info->write_png24, mng_info->write_png32,
+                          mng_info->write_png48, mng_info->write_png64,
+                          mng_info->IsPalette, image_matte
+                          );
   rowbytes=image->columns;
-  if (image->depth <= 8)
+  if (image_depth <= 8)
     {
       if (mng_info->write_png24)
         rowbytes*=3;
       else if (mng_info->write_png32)
         rowbytes*=4;
-      else if (!mng_info->write_png8 &&
-               ((mng_info->optimize || mng_info->IsPalette) &&
+      else if (!mng_info->write_png8 && (mng_info->IsPalette &&
                 IsGrayImage(image,&image->exception)))
-        rowbytes*=(image->matte ? 2 : 1);
+        rowbytes*=(image_matte ? 2 : 1);
       else
         {
           if (!mng_info->IsPalette)
-            rowbytes*=(image->matte ? 4 : 3);
+            rowbytes*=(image_matte ? 4 : 3);
         }
     }
   else
     {
-      if ((mng_info->optimize || mng_info->IsPalette) &&
+      if (mng_info->write_png48)
+        rowbytes*=6;
+
+      else if (mng_info->write_png64)
+        rowbytes*=8;
+
+      else if (mng_info->IsPalette &&
           IsGrayImage(image,&image->exception))
-        rowbytes*=(image->matte ? 4 : 2);
+        rowbytes*=(image_matte ? 4 : 2);
+
       else
-        rowbytes*=(image->matte ? 8 : 6);
+        rowbytes*=(image_matte ? 8 : 6);
     }
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                          "  Allocating %lu bytes of memory for pixels",rowbytes);
+                          "  Allocating %lu bytes of memory for pixels",
+                          rowbytes);
   png_pixels=MagickAllocateMemory(unsigned char *,rowbytes);
   if (png_pixels == (unsigned char *) NULL)
-    ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,image);
+    png_error(ping, "Could not allocate png_pixels");
   /*
     Initialize image scanlines.
   */
   num_passes=png_set_interlace_handling(ping);
   if ((!mng_info->write_png8 && !mng_info->write_png24 &&
-       !mng_info->write_png32) && (mng_info->optimize ||
-                                   mng_info->IsPalette ||
-                                   image_info->type == BilevelType) &&
-      !image->matte && IsMonochromeImage(image,&image->exception))
+       !mng_info->write_png32 && !mng_info->write_png48 &&
+       !mng_info->write_png64) && (mng_info->IsPalette ||
+       image_info->type == BilevelType) &&
+       !image_matte &&
+       IsMonochromeImage(image,&image->exception))
     for (pass=0; pass < num_passes; pass++)
       {
         /*
@@ -7243,7 +7810,8 @@ static unsigned int WriteOnePNGImage(Mng
                                 "  pass %d, Image Is Monochrome",pass);
         for (y=0; y < (long) image->rows; y++)
           {
-            if (!AcquireImagePixels(image,0,y,image->columns,1,&image->exception))
+            if (!AcquireImagePixels(image,0,y,image->columns,1,
+                                    &image->exception))
               break;
             if (mng_info->IsPalette)
               (void) ExportImagePixelArea(image,(QuantumType) GrayQuantum,
@@ -7258,7 +7826,7 @@ static unsigned int WriteOnePNGImage(Mng
               if (!MagickMonitor(SaveImageTag,(magick_uint64_t) y*(pass+1),
                                  (magick_uint64_t) image->rows*num_passes,
                                  &image->exception))
-                break;
+                  break;
 
           }
       }
@@ -7266,9 +7834,10 @@ static unsigned int WriteOnePNGImage(Mng
     for (pass=0; pass < num_passes; pass++)
       {
         if ((!mng_info->write_png8 && !mng_info->write_png24 &&
-             !mng_info->write_png32) &&
-            (!image->matte || (ping_info->bit_depth >= QuantumDepth)) &&
-            (mng_info->optimize || mng_info->IsPalette) &&
+             !mng_info->write_png32 && !mng_info->write_png48 &&
+             !mng_info->write_png64) &&
+            (!image_matte || (ping_bit_depth >= QuantumDepth)) &&
+            mng_info->IsPalette &&
             IsGrayImage(image,&image->exception))
           {
             if (logging)
@@ -7279,71 +7848,96 @@ static unsigned int WriteOnePNGImage(Mng
                 if (!AcquireImagePixels(image,0,y,image->columns,1,
                                         &image->exception))
                   break;
-                if (ping_info->color_type == PNG_COLOR_TYPE_GRAY)
+                if (ping_colortype == PNG_COLOR_TYPE_GRAY)
                   {
                     if (mng_info->IsPalette)
-                      (void) ExportImagePixelArea(image,(QuantumType) GrayQuantum,
+                      (void) ExportImagePixelArea(image,
+                                                  (QuantumType) GrayQuantum,
                                                   quantum_size,png_pixels,0,0);
                     else
-                      (void) ExportImagePixelArea(image,(QuantumType) RedQuantum,
-                                                  quantum_size,png_pixels,0,0);
+                      (void) ExportImagePixelArea(image,
+                                                  (QuantumType) RedQuantum,
+                                                  quantum_size,
+                                                 png_pixels,0,0);
+                  }
+                else if (ping_colortype == PNG_COLOR_TYPE_PALETTE)
+                  {
+                    (void) ExportImagePixelArea(image,(QuantumType)
+                                                IndexQuantum,
+                                                quantum_size,
+                                                png_pixels,0,0);
                   }
                 else /* PNG_COLOR_TYPE_GRAY_ALPHA */
                   {
-                    (void) ExportImagePixelArea(image,(QuantumType) GrayAlphaQuantum,
-                                                quantum_size,png_pixels,0,0);
+                    (void) ExportImagePixelArea(image,(QuantumType)
+                                                GrayAlphaQuantum,
+                                                quantum_size,
+                                                png_pixels,0,0);
                   }
                 png_write_row(ping,png_pixels);
                 if (image->previous == (Image *) NULL)
                   if (!MagickMonitor(SaveImageTag,(magick_uint64_t) y*(pass+1),
                                      (magick_uint64_t) image->rows*num_passes,
                                      &image->exception))
-                    break;
+                      break;
               }
           }
         else
           for (pass=0; pass < num_passes; pass++)
             {
-              if ((image->depth > 8) ||
-                  (mng_info->write_png24 ||
-                   mng_info->write_png32 ||
+              if ((image_depth > 8) ||
+                  (mng_info->write_png24 || mng_info->write_png32 ||
+                   mng_info->write_png48 || mng_info->write_png64 ||
                    (!mng_info->write_png8 && !mng_info->IsPalette)))
                 {
                   if (logging)
                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                          "  pass %d, Image Is RGB, PNG colortype is %s (%d)",pass,
-                                          PngColorTypeToString(ping_info->color_type),
-                                          ping_info->color_type);
+                                          "  pass %d, Image Is RGB,"
+                                          " PNG colortype is %s (%d)",pass,
+                                          PngColorTypeToString(
+                                             ping_colortype),
+                                          ping_colortype);
                   for (y=0; y < (long) image->rows; y++)
                     {
                       if (!AcquireImagePixels(image,0,y,image->columns,1,
                                               &image->exception))
                         break;
-                      if (ping_info->color_type == PNG_COLOR_TYPE_GRAY)
+                      if (ping_colortype == PNG_COLOR_TYPE_GRAY)
                         {
                           if (image->storage_class == DirectClass)
-                            (void) ExportImagePixelArea(image,(QuantumType) RedQuantum,
-                                                        quantum_size,png_pixels,0,0);
+                            (void) ExportImagePixelArea(image,(QuantumType)
+                                                        RedQuantum,
+                                                        quantum_size,
+                                                        png_pixels,0,0);
                           else
-                            (void) ExportImagePixelArea(image,(QuantumType) GrayQuantum,
-                                                        quantum_size,png_pixels,0,0);
+                            (void) ExportImagePixelArea(image,(QuantumType)
+                                                        GrayQuantum,
+                                                        quantum_size,
+                                                        png_pixels,0,0);
                         }
-                      else if (ping_info->color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
-                        (void) ExportImagePixelArea(image,(QuantumType) GrayAlphaQuantum,
-                                                    quantum_size,png_pixels,0,0);
-                      else if (image->matte)
-                        (void) ExportImagePixelArea(image,(QuantumType) RGBAQuantum,
-                                                    quantum_size,png_pixels,0,0);
+                      else if (ping_colortype ==
+                               PNG_COLOR_TYPE_GRAY_ALPHA)
+                        (void) ExportImagePixelArea(image,(QuantumType)
+                                                    GrayAlphaQuantum,
+                                                    quantum_size,
+                                                    png_pixels,0,0);
+                      else if (image_matte)
+                        (void) ExportImagePixelArea(image,(QuantumType)
+                                                    RGBAQuantum,
+                                                    quantum_size,
+                                                    png_pixels,0,0);
                       else
                         {
-                          (void) ExportImagePixelArea(image,(QuantumType) RGBQuantum,
-                                                      quantum_size,png_pixels,0,0);
+                          (void) ExportImagePixelArea(image,(QuantumType)
+                                                      RGBQuantum,
+                                                      quantum_size,
+                                                      png_pixels,0,0);
                         }
                       png_write_row(ping,png_pixels);
                       if (image->previous == (Image *) NULL)
                         if (!MagickMonitor(SaveImageTag,(magick_uint64_t) y*(pass+1),
-                                           (magick_uint64_t) image->rows*num_passes,
-                                           &image->exception))
+                            (magick_uint64_t) image->rows*num_passes,
+                            &image->exception))
                           break;
                     }
                   if (logging)
@@ -7354,27 +7948,35 @@ static unsigned int WriteOnePNGImage(Mng
                 {
                   if (logging)
                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                          "  pass %d, Image Is RGB, 16-bit GRAY, or GRAY_ALPHA",pass);
+                                          "  pass %d, Image Is RGB,"
+                                          " 16-bit GRAY, or GRAY_ALPHA",pass);
                   for (y=0; y < (long) image->rows; y++)
                     {
                       if (!AcquireImagePixels(image,0,y,image->columns,1,
                                               &image->exception))
                         break;
-                      if (ping_info->color_type == PNG_COLOR_TYPE_GRAY)
-                        (void) ExportImagePixelArea(image,(QuantumType) GrayQuantum,
-                                                    quantum_size,png_pixels,0,0);
-                      else if (ping_info->color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
-                        (void) ExportImagePixelArea(image,(QuantumType) GrayAlphaQuantum,
-                                                    quantum_size,png_pixels,0,0);
+                      if (ping_colortype == PNG_COLOR_TYPE_GRAY)
+                        (void) ExportImagePixelArea(image,(QuantumType)
+                                                    GrayQuantum,
+                                                    quantum_size,
+                                                    png_pixels,0,0);
+                      else if (ping_colortype ==
+                               PNG_COLOR_TYPE_GRAY_ALPHA)
+                        (void) ExportImagePixelArea(image,(QuantumType)
+                                                    GrayAlphaQuantum,
+                                                    quantum_size,
+                                                    png_pixels,0,0);
                       else
-                        (void) ExportImagePixelArea(image,(QuantumType) IndexQuantum,
-                                                    quantum_size,png_pixels,0,0);
+                        (void) ExportImagePixelArea(image,(QuantumType)
+                                                    IndexQuantum,
+                                                    quantum_size,
+                                                    png_pixels,0,0);
                       png_write_row(ping,png_pixels);
                       if (image->previous == (Image *) NULL)
                         if (!MagickMonitor(SaveImageTag,(magick_uint64_t) y*(pass+1),
-                                           (magick_uint64_t) image->rows*num_passes,
-                                           &image->exception))
-                          break;
+                            (magick_uint64_t) image->rows*num_passes,
+                             &image->exception))
+                            break;
                     }
                 }
             }
@@ -7385,42 +7987,42 @@ static unsigned int WriteOnePNGImage(Mng
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "  Writing PNG image data");
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "    Width: %lu",ping_info->width);
+                            "    Width: %lu",
+                            (unsigned long)ping_width);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "    Height: %lu",ping_info->height);
+                            "    Height: %lu",
+                            (unsigned long)ping_height);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "    PNG sample depth: %d",ping_info->bit_depth);
+                            "    PNG sample depth: %d",ping_bit_depth);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "    PNG color type: %s (%d)",
-                            PngColorTypeToString(ping_info->color_type),
-                            ping_info->color_type);
+                            PngColorTypeToString(ping_colortype),
+                            ping_colortype);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "    PNG Interlace method: %d",
-                            ping_info->interlace_type);
+                            ping_interlace_method);
     }
   /*
     Generate text chunks.
   */
-#if (PNG_LIBPNG_VER <= 10005)
-  ping_info->num_text=0;
-#endif
   attribute=GetImageAttribute(image,(char *) NULL);
   for ( ; attribute != (const ImageAttribute *) NULL;
         attribute=attribute->next)
     {
-#if (PNG_LIBPNG_VER > 10005)
       png_textp
         text;
-#endif
 
       if (*attribute->key == '[')
         continue;
-#if (PNG_LIBPNG_VER > 10005)
-# if PNG_LIBPNG_VER >= 14000
-      text=(png_textp) png_malloc(ping, (png_alloc_size_t) sizeof(png_text));
-# else
-      text=(png_textp) png_malloc(ping,(png_size_t) sizeof(png_text));
-# endif
+      if (LocaleCompare(attribute->key,"png:IHDR.color-type-orig") == 0 ||
+          LocaleCompare(attribute->key,"png:IHDR.bit-depth-orig") == 0)
+        continue;
+#if PNG_LIBPNG_VER >= 14000
+            text=(png_textp) png_malloc(ping,
+                 (png_alloc_size_t) sizeof(png_text));
+#else
+            text=(png_textp) png_malloc(ping,(png_size_t) sizeof(png_text));
+#endif
       text[0].key=attribute->key;
       text[0].text=attribute->value;
       text[0].text_length=strlen(attribute->value);
@@ -7436,47 +8038,74 @@ static unsigned int WriteOnePNGImage(Mng
         }
       png_set_text(ping,ping_info,text,1);
       png_free(ping,text);
-#else
-      /* Work directly with ping_info struct; png_set_text before libpng version
-       * 1.0.5a is leaky */
-      if (ping_info->num_text == 0)
-        {
-          ping_info->text=MagickAllocateMemory(png_text *,256*sizeof(png_text));
-          if (ping_info->text == (png_text *) NULL)
-            (void) ThrowException(&image->exception,(ExceptionType)
-                                  ResourceLimitError,MemoryAllocationFailed,
-                                  image->filename);
-        }
-      i=ping_info->num_text++;
-      if (i > 255)
-        (void) ThrowException(&image->exception,(ExceptionType)
-                              ResourceLimitError,
-                              "Cannot write more than 256 PNG text chunks",
-                              image->filename);
-      ping_info->text[i].key=attribute->key;
-      ping_info->text[i].text=attribute->value;
-      ping_info->text[i].text_length=strlen(attribute->value);
-      ping_info->text[i].compression=image_info->compression == NoCompression ||
-        (image_info->compression == UndefinedCompression &&
-         ping_info->text[i].text_length < 128) ? -1 : 0;
-      if (logging)
-        {
-          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                "  Setting up text chunk");
-          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                "    keyword: %s",ping_info->text[i].key);
-        }
-#endif
     }
+
+  /* write eXIf profile */
+  {
+    ImageProfileIterator
+      *profile_iterator;
+
+    profile_iterator=AllocateImageProfileIterator(image);
+    if (profile_iterator)
+      {
+        const char
+          *profile_name;
+
+        const unsigned char
+          *profile_info;
+
+        size_t
+          profile_length;
+
+        while (NextImageProfile(profile_iterator,&profile_name,&profile_info,
+                                &profile_length) != MagickFail)
+          {
+            if (LocaleCompare(profile_name,"exif") == 0)
+              {
+                png_uint_32
+                  length;
+                unsigned char
+                  chunk[4];
+                const unsigned char
+                  *data;
+
+                (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                   "  Have eXIf profile");
+
+                data=profile_info;
+
+                length=(png_uint_32) profile_length;
+
+                PNGType(chunk,mng_eXIf);
+
+                if (length < 7)
+                  break;  /* othewise crashes */
+
+                /* skip the "Exif\0\0" JFIF Exif Header ID */
+                length -= 6;
+
+                LogPNGChunk(logging,chunk,length);
+                (void) WriteBlobMSBULong(image,length);
+                (void) WriteBlob(image,4,chunk);
+                (void) WriteBlob(image,length,data+6);
+                (void) WriteBlobMSBULong(image,crc32(crc32(0,chunk,4),
+                  data+6, (uInt) length));
+                break;
+              }
+          }
+        DeallocateImageProfileIterator(profile_iterator);
+      }
+    }
+
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "  Writing PNG end info");
   png_write_end(ping,ping_info);
   if (mng_info->need_fram && (int) image->dispose == BackgroundDispose)
     {
-      if (mng_info->page.x || mng_info->page.y || (ping_info->width !=
+      if (mng_info->page.x || mng_info->page.y || (ping_width !=
                                                    mng_info->page.width) ||
-          (ping_info->height != mng_info->page.height))
+          (ping_height != mng_info->page.height))
         {
           unsigned char
             chunk[32];
@@ -7496,10 +8125,11 @@ static unsigned int WriteOnePNGImage(Mng
           PNGLong(chunk+10,(png_uint_32) (0L)); /* temporary 0 delay */
           chunk[14]=0; /* clipping boundaries delta type */
           PNGLong(chunk+15,(png_uint_32) (mng_info->page.x)); /* left cb */
-          PNGLong(chunk+19,(png_uint_32) (mng_info->page.x + ping_info->width));
+          PNGLong(chunk+19,(png_uint_32) (mng_info->page.x +
+                                          ping_width));
           PNGLong(chunk+23,(png_uint_32) (mng_info->page.y)); /* top cb */
           PNGLong(chunk+27,(png_uint_32) (mng_info->page.y +
-                                          ping_info->height));
+                                          ping_height));
           (void) WriteBlob(image,31,(char *) chunk);
           (void) WriteBlobMSBULong(image,crc32(0,chunk,31));
           mng_info->old_framing_mode=4;
@@ -7510,33 +8140,19 @@ static unsigned int WriteOnePNGImage(Mng
     }
   if (mng_info->write_mng && !mng_info->need_fram &&
       ((int) image->dispose == 3))
-    (void) ThrowException2(&image->exception,(ExceptionType) CoderError,
-                           "Cannot convert GIF with disposal method 3 to MNG-LC",
-                           (char *) NULL);
+    png_error(ping, "Cannot convert GIF with disposal method 3 to MNG-LC");
   image->depth=save_image_depth;
 
   /* Save depth actually written */
 
-  s[0]=(char) ping_info->bit_depth;
+  s[0]=(char) ping_bit_depth;
   s[1]='\0';
 
-  (void) SetImageAttribute(image,"[png_bit_depth]",s);
+  (void) SetImageAttribute(image,"[png:bit-depth-written]",s);
 
   /*
     Free PNG resources.
   */
-#if (PNG_LIBPNG_VER < 10007)
-  if (ping_info->valid & PNG_INFO_PLTE)
-    {
-      MagickFreeMemory(ping_info->palette);
-      ping_info->valid&=(~PNG_INFO_PLTE);
-    }
-#endif
-  if (ping_info->valid & PNG_INFO_tRNS)
-    {
-      MagickFreeMemory(ping_info->trans);
-      ping_info->valid&=(~PNG_INFO_tRNS);
-    }
   png_destroy_write_struct(&ping,&ping_info);
 
   MagickFreeMemory(png_pixels);
@@ -7545,14 +8161,101 @@ static unsigned int WriteOnePNGImage(Mng
   LiberateSemaphoreInfo(&png_semaphore);
 #endif
 
+
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "  exit WriteOnePNGImage()");
-  return (True);
+  return (MagickPass);
+
+  /* } end of setjmp-controlled block */
+
   /*  End write one PNG image */
 }
 
-static unsigned int WritePNGImage(const ImageInfo *image_info,Image *image)
+/*
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%                                                                             %
+%                                                                             %
+%                                                                             %
+%   W r i t e P N G I m a g e                                                 %
+%                                                                             %
+%                                                                             %
+%                                                                             %
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+%  WritePNGImage() writes a Portable Network Graphics (PNG) or
+%  Multiple-image Network Graphics (MNG) image file.
+%
+%  MNG support written by Glenn Randers-Pehrson, glennrp@image...
+%
+%  The format of the WritePNGImage method is:
+%
+%      MagickPassFail WritePNGImage(const ImageInfo *image_info,Image *image)
+%
+%  A description of each parameter follows:
+%
+%    o image_info: the image info.
+%
+%    o image:  The image.
+%
+%  Returns MagickPass on success, MagickFail on failure.
+%
+%  While the datastream written is always in PNG format and normally
+%  would be given the "png" file extension, this method also writes
+%  the following pseudo-formats which are subsets of PNG:
+%
+%    o PNG8:  An 8-bit indexed PNG datastream is written.
+%             If transparency is present, the tRNS chunk
+%             must only have values 0 and 255 (i.e., transparency is binary:
+%             fully opaque or fully transparent).  The pixels contain 8-bit
+%             indices even if they could be represented with 1, 2, or 4 bits.
+%             Note: grayscale images will be written as indexed PNG files
+%             even though the PNG grayscale type might be slightly more
+%             efficient.
+%
+%    o PNG24: An 8-bit per sample RGB PNG datastream is written.  The tRNS
+%             chunk can be present to convey binary transparency by naming
+%             one of the colors as transparent.
+%
+%    o PNG32: An 8-bit per sample RGBA PNG is written.  Partial
+%             transparency is permitted, i.e., the alpha sample for
+%             each pixel can have any value from 0 to 255. The alpha
+%             channel is present even if the image is fully opaque.
+%
+%    o PNG48:   A 16-bit per sample RGB PNG datastream is written.  The tRNS
+%               chunk can be present to convey binary transparency by naming
+%               one of the colors as transparent.  If the image has more
+%               than one transparent color, has semitransparent pixels, or
+%               has an opaque pixel with the same RGB components as the
+%               transparent color, an image is not written.
+%
+%    o PNG64:   A 16-bit per sample RGBA PNG is written.  Partial
+%               transparency is permitted, i.e., the alpha sample for
+%               each pixel can have any value from 0 to 65535. The alpha
+%               channel is present even if the image is fully opaque.
+%
+%    o PNG00:   A PNG that inherits its colortype and bit-depth from the input
+%               image, if the input was a PNG, is written.  If these values
+%               cannot be found, then "PNG00" falls back to the regular "PNG"
+%               format.
+%
+%  If the image cannot be written in the requested PNG8|24|32|48|64
+%  format without loss, a PNG file will not be written, and MagickFail
+%  will be returned.  Since image encoders should not be responsible for
+%  the "heavy lifting", the user should make sure that GraphicsMagick has
+%  already reduced the image depth and number of colors and limit
+%  transparency to binary transparency prior to attempting to write the
+%  image in a format that is subject to depth, color, or transparency
+%  limitations.
+%
+%  TODO: Enforce the previous paragraph.
+%
+%  TODO: Allow all other PNG subformats to be requested via new
+%        "-define png:bit-depth -define png:color-type" options.
+%
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+*/
+static MagickPassFail WritePNGImage(const ImageInfo *image_info,Image *image)
 {
   MngInfo
     *mng_info;
@@ -7573,13 +8276,13 @@ static unsigned int WritePNGImage(const
   assert(image->signature == MagickSignature);
   logging=LogMagickEvent(CoderEvent,GetMagickModule(),"enter WritePNGImage()");
   status=OpenBlob(image_info,image,WriteBinaryBlobMode,&image->exception);
-  if (status == False)
+  if (status == MagickFalse)
     ThrowWriterException(FileOpenError,UnableToOpenFile,image);
 
   /*
     Allocate a MngInfo structure.
   */
-  have_mng_structure=False;
+  have_mng_structure=MagickFalse;
   mng_info=MagickAllocateMemory(MngInfo *,sizeof(MngInfo));
   if (mng_info == (MngInfo *) NULL)
     ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,image);
